//------------------------------------------------------------------
#property  copyright "mladen"
#property  link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  20
#property indicator_level2  80

//
//
//
//
//

extern int MaPeriod    = 25;
extern int MaMethod    = MODE_SMA;
extern int MaPrice     = PRICE_CLOSE;
extern int RsiPeriod1  = 14;
extern int RsiPeriod2  = 14;

double value[];
double valueda[];
double valuedb[];
double temp1[];
double temp2[];
double slope[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,valueda);
   SetIndexBuffer(2,valuedb);
   SetIndexBuffer(3,temp1);
   SetIndexBuffer(4,temp2);
   SetIndexBuffer(5,slope);
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,valueda,valuedb);
   for(i=limit; i>=0; i--) temp1[i] = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
   for(i=limit; i>=0; i--) temp2[i] = iRSIOnArray(temp1,0,RsiPeriod1,i);
   for(i=limit; i>=0; i--)
   {
      value[i]    = iRSIOnArray(temp2,0,RsiPeriod2,i);
      valueda[i] = EMPTY_VALUE;
      valuedb[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];      
         if (value[i]>value[i+1]) slope[i] =  1;
         if (value[i]<value[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,valueda,valuedb,value);
   }         
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}